/*
 * Copyright (C) Trimble 2021 ...
 *
 * ?????
 *
*/
//******************************************************************************
// Version history:
// 1.0 Jan-21             Initial version.
//
//******************************************************************************

#ifndef __GPIODIF_H__
#define __GPIODIF_H__

#define	HIGH            1
#define LOW             0

#define RST_PIN_ACTIVE		HIGH
#define RST_PIN_INACTIVE	LOW

#define TEST_PIN_ACTIVE		HIGH
#define TEST_PIN_INACTIVE	LOW

// BSL Control Pins
#define MCU_BSL_EN_INIT			LOW		
#define MCU_RESET_INIT			LOW
#define CPU_LED_INIT			HIGH

typedef struct sig_atrib
{
	char chip_name_store[32];
	uint line_offset;
   	struct gpiod_line *chip_line_h; 
} signal_atributes;

//*****************************************************************************
//
// API Function prototypes
//
//*****************************************************************************
void GPIO_IF_line_config(const char *signal_name);
void GPIO_IF_setOutputValueOnPin(struct gpiod_line *chip_line_h, int output_value);
int GPIO_IF_getInputValueFromPin(struct gpiod_line *chip_line_h);
void GPIO_IF_toggleOutputOnPin(struct gpiod_line *chip_line_h);
void GPIO_IF_release_lines();

#endif //   __GPIODIF_H__